package com.tzld.piaoquan.recommend.server.config;

import lombok.Data;
import org.springframework.boot.context.properties.ConfigurationProperties;

/**
 * @author dyp
 */
@ConfigurationProperties(
        prefix = "spring.data.mongodb"
)
@Data
public class CustomMongoProperties {
    private String host;
    private Integer port;
    private String uri;
    private String database;
    private String username;
    private char[] password;
    private String replicaSetName;

    // 连接池配置 单位ms
    private long maxConnectionIdleTime;
    private long maxConnectionLifeTime;
    private long maxWaitTime;
    private int minSize;
    private int maxSize;

    // socket
    private int readTimeout;
    private int connectTimeout;
}
