package com.tzld.piaoquan.recommend.server.service.rank;

import com.tzld.piaoquan.recommend.server.service.rank.strategy.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class RankRouter {
    @Autowired
    private RankService rankService;
    @Autowired
    private RankStrategy4Rankv2Model rankStrategy4Rankv2Model;
    @Autowired
    private RankStrategy4RankModel rankStrategy4RankModel;
    @Autowired
    private RankStrategy4Density rankStrategy4Density;

    @Autowired
    private RankStrategyFlowThompsonModel rankStrategyFlowThompsonModel;


    public RankResult rank(RankParam param) {
        String abCode = param.getAbCode();
        if (abCode == null) {
            return rankService.rank(param);
        }
        switch (abCode){
            case "60106":
                return rankStrategy4Rankv2Model.rank(param);
            case "60101":
                return rankStrategy4RankModel.rank(param);
            case "60098":
            case "60111":
            case "60112":
            case "60113":
            case "60114":
            case "60115":
            case "60116":
            case "60117":
            case "60118":
            case "60119":
                return rankStrategy4Density.rank(param);
            case "60107":
                return rankStrategyFlowThompsonModel.rank(param);
            default:
                break;
        }
        return rankService.rank(param);
    }
}

