package com.tzld.piaoquan.recommend.server.service.rank.processor;
import com.tzld.piaoquan.recommend.server.model.Video;

import java.text.SimpleDateFormat;
import java.util.*;

public class RankProcessorTagFilter {

    public static void tagFitlter(List<Video> rov, List<Video> flow, Map<String, Map<String, String>> rule) {

        Map<String, List<String>> tag2Dates = new HashMap<>();
//        Map<String, List<String>> tag2Apps = new HashMap<>();
        Map<String, Integer> tag2Hour = new HashMap<>();
        for (Map.Entry<String, Map<String, String>> entry : rule.entrySet()){
            String key = entry.getKey();
            Map<String, String> value = entry.getValue();
            if (value.containsKey("date")){
                tag2Dates.put(key, Arrays.asList(value.get("date").split(",")));
            }
//            if (value.containsKey("app")){
//                tag2Apps.put(key, Arrays.asList(value.get("app").split(",")));
//            }
            if (value.containsKey("hour")){
                tag2Hour.put(key, Integer.valueOf(value.get("hour")));
            }
        }

        Calendar calendar = Calendar.getInstance();
        String date = new SimpleDateFormat("yyyyMMdd").format(calendar.getTime());
        Integer hour = Integer.valueOf(new SimpleDateFormat("HH").format(calendar.getTime()));

        Iterator<Video> iterator = rov.iterator();
        while (iterator.hasNext()) {
            Video video = iterator.next();
            List<String> tags = video.getTags();
            boolean filter = false;
            for (String tag : tags){
                if (tag2Dates.containsKey(tag) && !tag2Dates.get(tag).isEmpty() && !tag2Dates.get(tag).contains(date)){
                    // 如果有日期存在，但日期没有命中，则不过滤，跳过即可。
                    continue;
                }
                if (tag2Hour.containsKey(tag) && hour >= tag2Hour.get(tag)){
                    filter = true;
                }
            }
            if (filter){
                iterator.remove();
            }
        }

        iterator = flow.iterator();
        while (iterator.hasNext()) {
            Video video = iterator.next();
            List<String> tags = video.getTags();
            boolean filter = false;
            for (String tag : tags){
                if (tag2Dates.containsKey(tag) && !tag2Dates.get(tag).isEmpty() && !tag2Dates.get(tag).contains(date)){
                    // 如果有日期存在，但日期没有命中，则不过滤，跳过即可。
                    continue;
                }
                if (tag2Hour.containsKey(tag) && hour >= tag2Hour.get(tag)){
                    filter = true;
                }
            }
            if (filter){
                iterator.remove();
            }
        }
    }


}
